#include <stdlib.h>

#include "obj_dir/Vga.h"
#include "tb.h"

// Модули
Vga* mod_vga;

// Инициализация
void App::init() {

    mod_vga = new Vga();
    memory  = (unsigned char*) malloc(2048);

    // Инициализировать
    for (int i = 0; i < 1024; i++) memory[i] = i;
    for (int i = 0; i < 1024; i++) memory[i + 1024] = font8x8[i];
}

// Основной обработчик (TOP-уровень)
void App::tick() {

    // Обработка событий клавиатуры
    kbd_pop(ps_clock, ps_data);

    // Данные из памяти
    mod_vga->char_data = memory[ mod_vga->char_addr        ];
    mod_vga->font_data = memory[ mod_vga->font_addr + 1024 ];

    // Обработка VGA
    mod_vga->clock = 0; mod_vga->eval();
    mod_vga->clock = 1; mod_vga->eval();

    vga(mod_vga->HS, mod_vga->VS, 65536*(mod_vga->R << 4) + 256*(mod_vga->G << 4) + (mod_vga->B << 4));
}

// Главнвый цикл работы программы
int main(int argc, char **argv) {

    // -------------------------------------
    Verilated::commandArgs(argc, argv);
    App* app = new App(640, 400);
    // -------------------------------------

    while (app->main()) {

        for (int i = 0; i < 125000; i++)
            app->tick();
    }

    return app->destroy();
}
